diff --git a/drivers/soc/qcom/rpmpd.c b/drivers/soc/qcom/rpmpd.c
index ca4e18cb9e84..8f34fd826cbb 100644
--- a/drivers/soc/qcom/rpmpd.c
+++ b/drivers/soc/qcom/rpmpd.c
@@ -474,12 +474,12 @@ static struct rpmpd sscx_l26a_corner_vfc = {
 };
 
 static struct rpmpd *mdm9607_rpmpds[] = {
-	[MDM9607_VDDCX] =	&cx_s3a_lvl,
-	[MDM9607_VDDCX_AO] =	&cx_s3a_lvl_ao,
-	[MDM9607_VDDCX_VFL] =	&cx_s3a_lvl_vfl,
-	[MDM9607_VDDMX] =		&mx_l12a_lvl,
-	[MDM9607_VDDMX_AO] =	&mx_l12a_lvl_ao,
-	[MDM9607_VDDMX_VFL] =	&mx_l12a_lvl_vfl,
+	[MDM9607_VDDCX] = &cx_s3a_lvl,
+	[MDM9607_VDDCX_AO] = &cx_s3a_lvl_ao,
+	[MDM9607_VDDCX_VFL] = &cx_s3a_lvl_vfl,
+	[MDM9607_VDDMX] = &mx_l12a_lvl,
+	[MDM9607_VDDMX_AO] = &mx_l12a_lvl_ao,
+	[MDM9607_VDDMX_VFL] = &mx_l12a_lvl_vfl,
 };
 
 static const struct rpmpd_desc mdm9607_desc = {
@@ -489,9 +489,9 @@ static const struct rpmpd_desc mdm9607_desc = {
 };
 
 static struct rpmpd *msm8226_rpmpds[] = {
-	[MSM8226_VDDCX] =	&cx_s1a_corner,
-	[MSM8226_VDDCX_AO] =	&cx_s1a_corner_ao,
-	[MSM8226_VDDCX_VFC] =	&cx_s1a_corner_vfc,
+	[MSM8226_VDDCX] = &cx_s1a_corner,
+	[MSM8226_VDDCX_AO] = &cx_s1a_corner_ao,
+	[MSM8226_VDDCX_VFC] = &cx_s1a_corner_vfc,
 };
 
 static const struct rpmpd_desc msm8226_desc = {
@@ -501,14 +501,14 @@ static const struct rpmpd_desc msm8226_desc = {
 };
 
 static struct rpmpd *msm8939_rpmpds[] = {
-	[MSM8939_VDDMDCX] =	&md_s1a_corner,
-	[MSM8939_VDDMDCX_AO] =	&md_s1a_corner_ao,
-	[MSM8939_VDDMDCX_VFC] =	&md_s1a_corner_vfc,
-	[MSM8939_VDDCX] =	&cx_s2a_corner,
-	[MSM8939_VDDCX_AO] =	&cx_s2a_corner_ao,
-	[MSM8939_VDDCX_VFC] =	&cx_s2a_corner_vfc,
-	[MSM8939_VDDMX] =	&mx_l3a_corner,
-	[MSM8939_VDDMX_AO] =	&mx_l3a_corner_ao,
+	[MSM8939_VDDMDCX] = &md_s1a_corner,
+	[MSM8939_VDDMDCX_AO] = &md_s1a_corner_ao,
+	[MSM8939_VDDMDCX_VFC] = &md_s1a_corner_vfc,
+	[MSM8939_VDDCX] = &cx_s2a_corner,
+	[MSM8939_VDDCX_AO] = &cx_s2a_corner_ao,
+	[MSM8939_VDDCX_VFC] = &cx_s2a_corner_vfc,
+	[MSM8939_VDDMX] = &mx_l3a_corner,
+	[MSM8939_VDDMX_AO] = &mx_l3a_corner_ao,
 };
 
 static const struct rpmpd_desc msm8939_desc = {
@@ -518,11 +518,11 @@ static const struct rpmpd_desc msm8939_desc = {
 };
 
 static struct rpmpd *msm8916_rpmpds[] = {
-	[MSM8916_VDDCX] =	&cx_s1a_corner,
-	[MSM8916_VDDCX_AO] =	&cx_s1a_corner_ao,
-	[MSM8916_VDDCX_VFC] =	&cx_s1a_corner_vfc,
-	[MSM8916_VDDMX] =	&mx_l3a_corner,
-	[MSM8916_VDDMX_AO] =	&mx_l3a_corner_ao,
+	[MSM8916_VDDCX] = &cx_s1a_corner,
+	[MSM8916_VDDCX_AO] = &cx_s1a_corner_ao,
+	[MSM8916_VDDCX_VFC] = &cx_s1a_corner_vfc,
+	[MSM8916_VDDMX] = &mx_l3a_corner,
+	[MSM8916_VDDMX_AO] = &mx_l3a_corner_ao,
 };
 
 static const struct rpmpd_desc msm8916_desc = {
@@ -532,13 +532,13 @@ static const struct rpmpd_desc msm8916_desc = {
 };
 
 static struct rpmpd *msm8953_rpmpds[] = {
-	[MSM8953_VDDMD] =	&md_s1a_lvl,
-	[MSM8953_VDDMD_AO] =	&md_s1a_lvl_ao,
-	[MSM8953_VDDCX] =	&cx_s2a_lvl,
-	[MSM8953_VDDCX_AO] =	&cx_s2a_lvl_ao,
-	[MSM8953_VDDCX_VFL] =	&cx_s2a_lvl_vfl,
-	[MSM8953_VDDMX] =	&mx_s7a_lvl,
-	[MSM8953_VDDMX_AO] =	&mx_s7a_lvl_ao,
+	[MSM8953_VDDMD] = &md_s1a_lvl,
+	[MSM8953_VDDMD_AO] = &md_s1a_lvl_ao,
+	[MSM8953_VDDCX] = &cx_s2a_lvl,
+	[MSM8953_VDDCX_AO] = &cx_s2a_lvl_ao,
+	[MSM8953_VDDCX_VFL] = &cx_s2a_lvl_vfl,
+	[MSM8953_VDDMX] = &mx_s7a_lvl,
+	[MSM8953_VDDMX_AO] = &mx_s7a_lvl_ao,
 };
 
 static const struct rpmpd_desc msm8953_desc = {
@@ -548,12 +548,12 @@ static const struct rpmpd_desc msm8953_desc = {
 };
 
 static struct rpmpd *msm8976_rpmpds[] = {
-	[MSM8976_VDDCX] =	&cx_s2a_lvl,
-	[MSM8976_VDDCX_AO] =	&cx_s2a_lvl_ao,
-	[MSM8976_VDDCX_VFL] =	&cx_s2a_lvl_vfl,
-	[MSM8976_VDDMX] =	&mx_s6a_lvl,
-	[MSM8976_VDDMX_AO] =	&mx_s6a_lvl_ao,
-	[MSM8976_VDDMX_VFL] =	&mx_s6a_lvl_vfl,
+	[MSM8976_VDDCX] = &cx_s2a_lvl,
+	[MSM8976_VDDCX_AO] = &cx_s2a_lvl_ao,
+	[MSM8976_VDDCX_VFL] = &cx_s2a_lvl_vfl,
+	[MSM8976_VDDMX] = &mx_s6a_lvl,
+	[MSM8976_VDDMX_AO] = &mx_s6a_lvl_ao,
+	[MSM8976_VDDMX_VFL] = &mx_s6a_lvl_vfl,
 };
 
 static const struct rpmpd_desc msm8976_desc = {
@@ -563,13 +563,13 @@ static const struct rpmpd_desc msm8976_desc = {
 };
 
 static struct rpmpd *msm8994_rpmpds[] = {
-	[MSM8994_VDDCX] =	&cx_s1a_corner,
-	[MSM8994_VDDCX_AO] =	&cx_s1a_corner_ao,
-	[MSM8994_VDDCX_VFC] =	&cx_s1a_corner_vfc,
-	[MSM8994_VDDMX] =	&mx_s2a_corner,
-	[MSM8994_VDDMX_AO] =	&mx_s2a_corner_ao,
-	[MSM8994_VDDGFX] =	&gfx_s2b_corner,
-	[MSM8994_VDDGFX_VFC] =	&gfx_s2b_corner_vfc,
+	[MSM8994_VDDCX] = &cx_s1a_corner,
+	[MSM8994_VDDCX_AO] = &cx_s1a_corner_ao,
+	[MSM8994_VDDCX_VFC] = &cx_s1a_corner_vfc,
+	[MSM8994_VDDMX] = &mx_s2a_corner,
+	[MSM8994_VDDMX_AO] = &mx_s2a_corner_ao,
+	[MSM8994_VDDGFX] = &gfx_s2b_corner,
+	[MSM8994_VDDGFX_VFC] = &gfx_s2b_corner_vfc,
 };
 
 static const struct rpmpd_desc msm8994_desc = {
@@ -579,12 +579,12 @@ static const struct rpmpd_desc msm8994_desc = {
 };
 
 static struct rpmpd *msm8996_rpmpds[] = {
-	[MSM8996_VDDCX] =	&cx_s1a_corner,
-	[MSM8996_VDDCX_AO] =	&cx_s1a_corner_ao,
-	[MSM8996_VDDCX_VFC] =	&cx_s1a_corner_vfc,
-	[MSM8996_VDDMX] =	&mx_s2a_corner,
-	[MSM8996_VDDMX_AO] =	&mx_s2a_corner_ao,
-	[MSM8996_VDDSSCX] =	&sscx_l26a_corner,
+	[MSM8996_VDDCX] = &cx_s1a_corner,
+	[MSM8996_VDDCX_AO] = &cx_s1a_corner_ao,
+	[MSM8996_VDDCX_VFC] = &cx_s1a_corner_vfc,
+	[MSM8996_VDDMX] = &mx_s2a_corner,
+	[MSM8996_VDDMX_AO] = &mx_s2a_corner_ao,
+	[MSM8996_VDDSSCX] = &sscx_l26a_corner,
 	[MSM8996_VDDSSCX_VFC] =	&sscx_l26a_corner_vfc,
 };
 
@@ -595,16 +595,16 @@ static const struct rpmpd_desc msm8996_desc = {
 };
 
 static struct rpmpd *msm8998_rpmpds[] = {
-	[MSM8998_VDDCX] =		&rwcx0_lvl,
-	[MSM8998_VDDCX_AO] =		&rwcx0_lvl_ao,
-	[MSM8998_VDDCX_VFL] =		&rwcx0_lvl_vfl,
-	[MSM8998_VDDMX] =		&rwmx0_lvl,
-	[MSM8998_VDDMX_AO] =		&rwmx0_lvl_ao,
-	[MSM8998_VDDMX_VFL] =		&rwmx0_lvl_vfl,
-	[MSM8998_SSCCX] =		&rwsc0_lvl,
-	[MSM8998_SSCCX_VFL] =		&rwsc0_lvl_vfl,
-	[MSM8998_SSCMX] =		&rwsm0_lvl,
-	[MSM8998_SSCMX_VFL] =		&rwsm0_lvl_vfl,
+	[MSM8998_VDDCX] = &rwcx0_lvl,
+	[MSM8998_VDDCX_AO] = &rwcx0_lvl_ao,
+	[MSM8998_VDDCX_VFL] = &rwcx0_lvl_vfl,
+	[MSM8998_VDDMX] = &rwmx0_lvl,
+	[MSM8998_VDDMX_AO] = &rwmx0_lvl_ao,
+	[MSM8998_VDDMX_VFL] = &rwmx0_lvl_vfl,
+	[MSM8998_SSCCX] = &rwsc0_lvl,
+	[MSM8998_SSCCX_VFL] = &rwsc0_lvl_vfl,
+	[MSM8998_SSCMX] = &rwsm0_lvl,
+	[MSM8998_SSCMX_VFL] = &rwsm0_lvl_vfl,
 };
 
 static const struct rpmpd_desc msm8998_desc = {
@@ -630,16 +630,16 @@ static const struct rpmpd_desc qcs404_desc = {
 };
 
 static struct rpmpd *sdm660_rpmpds[] = {
-	[SDM660_VDDCX] =		&rwcx0_lvl,
-	[SDM660_VDDCX_AO] =		&rwcx0_lvl_ao,
-	[SDM660_VDDCX_VFL] =		&rwcx0_lvl_vfl,
-	[SDM660_VDDMX] =		&rwmx0_lvl,
-	[SDM660_VDDMX_AO] =		&rwmx0_lvl_ao,
-	[SDM660_VDDMX_VFL] =		&rwmx0_lvl_vfl,
-	[SDM660_SSCCX] =		&rwlc0_lvl,
-	[SDM660_SSCCX_VFL] =		&rwlc0_lvl_vfl,
-	[SDM660_SSCMX] =		&rwlm0_lvl,
-	[SDM660_SSCMX_VFL] =		&rwlm0_lvl_vfl,
+	[SDM660_VDDCX] = &rwcx0_lvl,
+	[SDM660_VDDCX_AO] = &rwcx0_lvl_ao,
+	[SDM660_VDDCX_VFL] = &rwcx0_lvl_vfl,
+	[SDM660_VDDMX] = &rwmx0_lvl,
+	[SDM660_VDDMX_AO] = &rwmx0_lvl_ao,
+	[SDM660_VDDMX_VFL] = &rwmx0_lvl_vfl,
+	[SDM660_SSCCX] = &rwlc0_lvl,
+	[SDM660_SSCCX_VFL] = &rwlc0_lvl_vfl,
+	[SDM660_SSCMX] = &rwlm0_lvl,
+	[SDM660_SSCMX_VFL] = &rwlm0_lvl_vfl,
 };
 
 static const struct rpmpd_desc sdm660_desc = {
@@ -649,14 +649,14 @@ static const struct rpmpd_desc sdm660_desc = {
 };
 
 static struct rpmpd *sm6115_rpmpds[] = {
-	[SM6115_VDDCX] =		&rwcx0_lvl,
-	[SM6115_VDDCX_AO] =		&rwcx0_lvl_ao,
-	[SM6115_VDDCX_VFL] =		&rwcx0_lvl_vfl,
-	[SM6115_VDDMX] =		&rwmx0_lvl,
-	[SM6115_VDDMX_AO] =		&rwmx0_lvl_ao,
-	[SM6115_VDDMX_VFL] =		&rwmx0_lvl_vfl,
-	[SM6115_VDD_LPI_CX] =		&rwlc0_lvl,
-	[SM6115_VDD_LPI_MX] =		&rwlm0_lvl,
+	[SM6115_VDDCX] = &rwcx0_lvl,
+	[SM6115_VDDCX_AO] = &rwcx0_lvl_ao,
+	[SM6115_VDDCX_VFL] = &rwcx0_lvl_vfl,
+	[SM6115_VDDMX] = &rwmx0_lvl,
+	[SM6115_VDDMX_AO] = &rwmx0_lvl_ao,
+	[SM6115_VDDMX_VFL] = &rwmx0_lvl_vfl,
+	[SM6115_VDD_LPI_CX] = &rwlc0_lvl,
+	[SM6115_VDD_LPI_MX] = &rwlm0_lvl,
 };
 
 static const struct rpmpd_desc sm6115_desc = {
@@ -666,12 +666,12 @@ static const struct rpmpd_desc sm6115_desc = {
 };
 
 static struct rpmpd *sm6125_rpmpds[] = {
-	[SM6125_VDDCX] =		&rwcx0_lvl,
-	[SM6125_VDDCX_AO] =		&rwcx0_lvl_ao,
-	[SM6125_VDDCX_VFL] =		&rwcx0_lvl_vfl,
-	[SM6125_VDDMX] =		&rwmx0_lvl,
-	[SM6125_VDDMX_AO] =		&rwmx0_lvl_ao,
-	[SM6125_VDDMX_VFL] =		&rwmx0_lvl_vfl,
+	[SM6125_VDDCX] = &rwcx0_lvl,
+	[SM6125_VDDCX_AO] = &rwcx0_lvl_ao,
+	[SM6125_VDDCX_VFL] = &rwcx0_lvl_vfl,
+	[SM6125_VDDMX] = &rwmx0_lvl,
+	[SM6125_VDDMX_AO] = &rwmx0_lvl_ao,
+	[SM6125_VDDMX_VFL] = &rwmx0_lvl_vfl,
 };
 
 static const struct rpmpd_desc sm6125_desc = {